<?php
/*
  $Id$

  Ship200 Bulk Processing Addon - 2.1

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2010 osCommerce

  Released under the GNU General Public License*/

require_once('includes/application_top.php');

$secret_key = MODULE_BOXES_SHIP200_BULK_KEY;
$order_status_import = MODULE_BOXES_SHIP200_BULK_ORDER_STATUS_IMPORT;
$order_status_tracking_bulk = MODULE_BOXES_SHIP200_BULK_ORDER_STATUS_TRACKING;

if (strtolower(MODULE_BOXES_SHIP200_BULK_STATUS) == 'false') {
    echo "Extension is disabled.";
    exit;
}
if ($secret_key == "" || $secret_key == '0') {
    echo "The Secret Key was never setup. Please refer to read_me file";
    exit;
}
if ($order_status_import == "0") {
    echo "Please Select Order Status From Admin for Order Import";
    exit;
}
if ($order_status_tracking_bulk == "0") {
    echo "Please Select Order Status From Admin for Update With Tracking";
    exit;
}

#Added for extra security

// Check that request is coming from Ship200 Server
$allowed_servers = file_get_contents('http://www.ship200.com/instructions/allowed_servers.txt');
if (!$allowed_servers) $allowed_servers = '173.192.194.99,173.192.194.98,108.58.55.190,45.33.71.107,45.33.73.63,45.33.89.56,45.33.85.63,97.107.136.135';

$servers_array = explode(",", $allowed_servers);

$server = 0;
foreach ($servers_array as $ip) {
    if ($_SERVER['REMOTE_ADDR'] == $ip) {
        $server = 1;
    }
}
	if($server != 1){echo "Incorrect Server"; exit;}
// Check that request is coming from Ship200 Server

if (isset($_REQUEST['id']) && $_REQUEST['id'] == $secret_key && $_POST['update_tracking'] == "") {

    $fields = array(

        //			Ship200 field name				your db field name

        //			cannot be changed			can be changed (see examples below)

        "Orderid" => "orders_id", // that will be used 'keyForUpdate' to update the tracking number back in the backend
        "Order_Date" => "date_purchased",

        //"Order_Status"			=>	"orders_status",

        "Name" => "delivery_name", //ps_customer table name

        "Company_Name" => "delivery_company", // ps_address table name
        //
        "Address_Line1" => "delivery_street_address",    // ps_address table name
        //
        "City" => "delivery_city",// ps_address table name

        "State" => "delivery_state", // 2 Letter State, example: NY, LA etc..

        "Zip" => "delivery_postcode",  //ps_address table name

        "Country" => "delivery_country",

        "Phone" => "customers_telephone",// ps_address table name

        "Email" => "customers_email_address", //ps_customer table name

        //			"Ship_Method"			=>	"id_carrier", //ps_orders //ps_carrier

        //			"Subtotal"			=>	"total_paid_tax_excl", //ps_orders

        //			"Shipping"			=>	"total_shipping",

        //			"Total"			=>	"total_paid",

        "items" => array("1" => "items"),

        "Weight" =>	array("1"=>"product_weight"),

        "Weight_Units" => array('lb' => "manual"), // Weight Units, valid values are lb and oz

        "Name_On_Invoice" => array(str_replace("http://", "", HTTP_SERVER) => "manual")

    );

    $orders_all = tep_db_query("select * from  orders where orders_status='" . $order_status_import . "'");

    while ($orders = tep_db_fetch_array($orders_all)) {
        $out .= "<order>\n";
        foreach ($fields as $key => $value) {
            if (is_array($value)) {
                $man = "";
                foreach ($value as $key2 => $value2) { /// if field is array

                    if ($value2 == "manual") {
                        $man .= clear($key2);

                        // Items
                    } elseif ($value2 == "items") {
                        unset($totals);
                        unset($item_title_array);
                        unset($items_qty_array);
                        unset($items_price_array);
                        unset($items_sku_array);
                        unset($items_id);

                        $orders_all_pro = tep_db_query("select * from  orders_products where orders_id='" . $orders['orders_id'] . "'");
                        while ($order_product = tep_db_fetch_array($orders_all_pro)) {
                            $item_title_array[] = $order_product['products_name'];
                            $items_qty_array[] = $order_product['products_quantity'];
                            $items_price_array[] = round($order_product['products_price'], 2);
                            $items_sku_array[] = $order_product['products_model'];
                            $items_id[] = clear($order_product['products_id']);

                        }
                        //titles
                        $man .= "\n<title><![CDATA[" . json_encode($item_title_array) . "]]></title>\n";

                        //itemid
                        $man .= "\n<itemid>" . json_encode($items_sku_array) . "</itemid>\n";
                        //qty
                        $man .= "\n<qty>" . json_encode($items_qty_array) . "</qty>\n";
                        //price
                        $man .= "\n<price>" . json_encode($items_price_array) . "</price>\n";


                        $orders_total = tep_db_query("select * from  orders_total where orders_id='" . $orders['orders_id'] . "'");
                        while ($totals = tep_db_fetch_array($orders_total)) {

                            if ($totals['class'] == "ot_subtotal") {
                                $man .= "\n<subtotal>" . clear(number_format($totals['value'], 2)) . "</subtotal>\n";
                            }
                            if ($totals['class'] == "ot_shipping") {
                                $man .= "\n<shipping>" . clear(number_format($totals['value'], 2)) . "</shipping>\n";
                            }
                            if ($totals['class'] == "ot_total") {
                                $man .= "\n<total>" . clear(number_format($totals['value'], 2)) . "</total>\n";
                            }
                            if ($totals['class'] == "ot_coupon") {
                                $man .= "\n<discount>" . clear(number_format($totals['value'], 2)) . "</discount>\n";
                            }
                        }

                    }elseif ($value2 == "product_weight"){
                        $sqlPartWithIds = implode(' OR products_id = ',$items_id);
                        $productWeightSql = tep_db_query("SELECT products_weight FROM products WHERE products_id = " . $sqlPartWithIds);

                        $weight = 0;
                        while ($row = tep_db_fetch_array($productWeightSql)) {
                            $weight += $row['products_weight'];
                        }
                        $man .= $weight;
                    }
                }

                $orders_status = tep_db_query("select * from  orders_status where orders_status_id='" . $orders['orders_status'] . "'");
                while ($status_name = tep_db_fetch_array($orders_status)) {
                    $out .= "<Order_Status>" . clear($status_name['orders_status_name']) . "</Order_Status>";
                }
                $orders_ship_method = tep_db_query("select * from  orders_total where orders_id='" . $orders['orders_id'] . "'");
                while ($shipname = tep_db_fetch_array($orders_ship_method)) {
                    if ($shipname['class'] == "ot_shipping") {
                        $out .= "<Ship_Method>" . clear($shipname['title']) . "</Ship_Method>";
                    }
                }
                $out .= "<$key>" . $man . "</$key>\n";

            } elseif ($value == "") {                         // if field is empty
                $out .= "<$key></$key>\n";
            } else {                                                // normal field
                $out .= "<$key>" . $orders[$value] . "</$key>\n";

            }
        }
        $out .= "</order>\n";
    }
    header("Content-type: text/xml; charset=utf-8");
    echo "<?xml version='1.0' encoding='ISO-8859-1'?>\n<orders>\n$out</orders>";

}elseif(isset($_POST['update_tracking']) && $_POST['update_tracking'] != "" && isset($_POST['secret_key']) && $_POST['secret_key'] == $secret_key){
    if(!isset($_POST['keyForUpdate'])||!isset($_POST['carrier'])||!isset($_POST['tracking'])){echo 'Missing params'; exit();}
    if(!isset($order_status_tracking_bulk) || $order_status_tracking_bulk == '' || $order_status_tracking_bulk == 0) $order_status_tracking_bulk = 3;

    $comment = addslashes($_POST['carrier']) . " tracking#: " . addslashes($_POST['tracking']);

    tep_db_query("insert into orders_status_history (comments,date_added,orders_id,orders_status_id,customer_notified) values ('" . $comment . "',now(),'" . $_POST['keyForUpdate'] . "','" . $order_status_tracking_bulk . "','0')");

    tep_db_query("update orders set orders_status = '" . $order_status_tracking_bulk . "', last_modified = now() WHERE orders_id = '" . $_POST['keyForUpdate'] . "'");

    echo "Tracking Number: Inserted";

} else {
//////////////// Not valid request ////////////////
    echo "Error: 1094";
}
exit;
//////////////// Clear Function ////////////////
function clear($value = "")
{
    $value = preg_replace("'<style[^>]*>.*</style>'siU", '', $value);
    $value = strip_tags($value);
    $value = str_replace("<", "&lt;", $value);
    $value = str_replace("&", "&amp;", $value);
    $value = str_replace(",", " ", $value);
    $value = str_replace("\n", " ", $value);
    $value = str_replace("\r", " ", $value);
    $value = str_replace("	", " ", $value);
    $value = str_replace("�", " ", $value);
    $value = preg_replace('/\<[^\>]+\>/', '', $value);
    #$value = urldecode(html_entity_decode($value));
    $value = preg_replace('/[\r\n]+/', '', $value);
    $value = preg_replace('/[\s]+$/', '', $value);
    $value = preg_replace('/[\s\t]+\xA0$/', '', $value);
    $value = substr($value, 0, 10000);
    $value = addslashes($value);
    return $value;
}